/**
 * My Title
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.TestBlueprint
import io.swagger.client.models.TestCase
import io.swagger.client.models.TestCasesRun
import io.swagger.client.models.TestRunBlueprint
import io.swagger.client.models.TestRunStatus
import io.swagger.client.models.TestSuit

import io.swagger.client.infrastructure.*

class TestCasesServiceApi(basePath: kotlin.String = "http://localhost:8080") : ApiClient(basePath) {

    /**
     * 
     * 
     * @param testCaseRun  (optional)
     * @param sessionId  (optional)
     * @return void
     */
    fun testCasesServiceAssignSession(testCaseRun: kotlin.String? = null, sessionId: kotlin.String? = null): Unit {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (testCaseRun != null) {
                put("testCaseRun", listOf(testCaseRun.toString()))
            }
            if (sessionId != null) {
                put("sessionId", listOf(sessionId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/assign-session", query = localVariableQuery
        )
        val response = request<Any?>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param stepRun  (optional)
     * @param status  (optional)
     * @return void
     */
    fun testCasesServiceChangeStateOfStepRun(stepRun: kotlin.String? = null, status: TestRunStatus? = null): Unit {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (stepRun != null) {
                put("stepRun", listOf(stepRun.toString()))
            }
            if (status != null) {
                put("status", listOf(status.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/change-step-run-state", query = localVariableQuery
        )
        val response = request<Any?>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @param title  (optional)
     * @return TestSuit
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceCreateSuit(projectId: kotlin.String? = null, title: kotlin.String? = null): TestSuit {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
            if (title != null) {
                put("title", listOf(title.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/suits/create", query = localVariableQuery
        )
        val response = request<TestSuit>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as TestSuit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @param projectId  (optional)
     * @param suitId  (optional)
     * @return TestSuit
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceCreateTest(body: TestBlueprint, projectId: kotlin.String? = null, suitId: kotlin.String? = null): TestSuit {
        val localVariableBody: kotlin.Any? = body
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
            if (suitId != null) {
                put("suitId", listOf(suitId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/tests/create", query = localVariableQuery
        )
        val response = request<TestSuit>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as TestSuit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return void
     */
    fun testCasesServiceCreateTestRun(body: TestRunBlueprint): Unit {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/create"
        )
        val response = request<Any?>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param runId  (optional)
     * @return kotlin.Array<TestCasesRun>
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceDeleteRun(runId: kotlin.String? = null): kotlin.Array<TestCasesRun> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (runId != null) {
                put("runId", listOf(runId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/delete", query = localVariableQuery
        )
        val response = request<kotlin.Array<TestCasesRun>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TestCasesRun>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @param id  (optional)
     * @return void
     */
    fun testCasesServiceDeleteSuit(projectId: kotlin.String? = null, id: kotlin.String? = null): Unit {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
            if (id != null) {
                put("id", listOf(id.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/suits/delete", query = localVariableQuery
        )
        val response = request<Any?>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @return kotlin.Array<TestCasesRun>
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceGetRunsList(projectId: kotlin.String? = null): kotlin.Array<TestCasesRun> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/list", query = localVariableQuery
        )
        val response = request<kotlin.Array<TestCasesRun>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TestCasesRun>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @param testId  (optional)
     * @return TestCase
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceGetTest(projectId: kotlin.String? = null, testId: kotlin.String? = null): TestCase {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
            if (testId != null) {
                put("testId", listOf(testId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/tests/tests/get", query = localVariableQuery
        )
        val response = request<TestCase>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as TestCase
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @param groupId  (optional)
     * @return kotlin.Array<TestCase>
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceGetTests(projectId: kotlin.String? = null, groupId: kotlin.String? = null): kotlin.Array<TestCase> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
            if (groupId != null) {
                put("groupId", listOf(groupId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/tests/tests/list", query = localVariableQuery
        )
        val response = request<kotlin.Array<TestCase>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TestCase>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param projectId  (optional)
     * @return kotlin.Array<TestSuit>
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceGetTestsTree(projectId: kotlin.String? = null): kotlin.Array<TestSuit> {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/tests/tests/tree", query = localVariableQuery
        )
        val response = request<kotlin.Array<TestSuit>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<TestSuit>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param runId  (optional)
     * @return TestCasesRun
     */
    @Suppress("UNCHECKED_CAST")
    fun testCasesServiceRunById(runId: kotlin.String? = null): TestCasesRun {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (runId != null) {
                put("runId", listOf(runId.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/tests/runs/get", query = localVariableQuery
        )
        val response = request<TestCasesRun>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as TestCasesRun
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
